#!/usr/bin/env python
# -*-Python-*-

## Copyright (C) 2004 Nikos Kouremenos <nkour@users.sourceforge.net>

## DailyCartoonApplet is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License as
## published by the Free Software Foundation; either version 2 of the
## License, or (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.

## You should have received a copy of the GNU General Public
## License along with this program; see the file COPYING.  If not,
## write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
## Boston, MA 02111-1307, USA

## Special thanks to: Arturo Gonzalez (http://www.pygtk.org/articles/applets_arturogf/)
## to Seth Nickell (http://www.gnome.org/~seth/gnome-blog/)
## and to Rubens Ramos ( http://gnochm.sf.net/ )
## I was code-inspired by those guys. Fortunately GPL allows such stuff to happen

#FIXME: if NO CARTOON for today don't show a grey window. HIDE IT!
#i think I got this, but when Two cartoons are shown, then one, the grey window won't resize
# so we'll have a large gray with ONE cartoon in it

import urllib
import HTMLParser
import gtk
import gobject
import gnome
import gnome.ui
import gnome.applet
import gconf
import sys
import time
import sre
import os

#import socket
#socket.setdefaulttimeout(10)
# throw socket.timeout exception after 10s,
# default is to wait a infinitly (or at least a very, very long time...)

try:	import psyco ; psyco.full()  # If present, use psyco to accelerate the program
except:	pass

appversion = '0.5.1'
CARTOON_DIR = '/tmp/' # FIXME: USER CAN CHANGE THIS

Dilbert = False # dilbert doesn't get parsed atm
#o peny-arcade ananeonete arketa spania [kathe 3 meres?]

def gconf_get_bool(key):
	return client.get_bool(gconf_prefs_prefix + '/' + key)
		
def gconf_set_bool(key, value):
	client.set_bool(gconf_prefs_prefix + '/' + key, value)


class ImageParser(HTMLParser.HTMLParser):
	def __init__(self):
		HTMLParser.HTMLParser.__init__(self)
		self.imageUrlList = []
	def handle_starttag(self, tag, attrs):
		if tag=='img':
			self.imageUrlList.append(dict(attrs)['src'])

class AlignedWindow(gtk.Window):

    def __init__(self, widgetToAlignWith):
        gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
        self.set_decorated(False)
        
        self.widgetToAlignWith = widgetToAlignWith

    def positionWindow(self):
        # Get our own dimensions & position
        self.realize()
        gtk.gdk.flush()
        ourWidth  = (self.window.get_geometry())[2]
        ourHeight = (self.window.get_geometry())[3]

        # Get the dimensions/position of the widgetToAlignWith
        self.widgetToAlignWith.realize()
        (entryX, entryY) = self.widgetToAlignWith.window.get_origin()
        entryWidth  = (self.widgetToAlignWith.window.get_geometry())[2]
        entryHeight = (self.widgetToAlignWith.window.get_geometry())[3]

        # Get the screen dimensions
        screenHeight = gtk.gdk.screen_height()
        screenWidth = gtk.gdk.screen_width()

        if entryX + ourWidth < screenWidth:
            # Align to the left of the entry
            newX = entryX
        else:
            # Align to the right of the entry
            newX = (entryX + entryWidth) - ourWidth

        if entryY + entryHeight + ourHeight < screenHeight:
            # Align to the bottom of the entry
            newY = entryY + entryHeight
        else:
            newY = entryY - ourHeight

        # -"Coordinates locked in captain."
        # -"Engage."
        self.move(newX, newY)
        self.show()

class Preferences:
	def __init__(self):
		#GCONF stuff
		client.add_dir(gconf_prefs_prefix, gconf.CLIENT_PRELOAD_ONELEVEL)
		
		client.notify_add (gconf_prefs_prefix + '/UF_enable', 
								self.UF_enable_changed)
		client.notify_add (gconf_prefs_prefix + '/PVP_enable',
								self.PVP_enable_changed)
		client.notify_add (gconf_prefs_prefix + '/PA_enable',
								self.PA_enable_changed)
	
	def UF_enable_changed(self, client, cnxn_id, entry, *args):
		if entry.value:
			if entry.value.type == gconf.VALUE_BOOL:
				global UF
				if entry.value.get_bool():
					UF = True
				else:
					UF = False
			else:
				print 'UF_enable_changed: non-bool value'
				
	def PVP_enable_changed(self, client, cnxn_id, entry, *args):
		if entry.value:
			if entry.value.type == gconf.VALUE_BOOL:
				global PVP
				if entry.value.get_bool():
					PVP = True
				else:
					PVP = False
			else:
				print 'PVP_enable_changed: non-bool value'
				
	def PA_enable_changed(self, client, cnxn_id, entry, *args):
		if entry.value:
			if entry.value.type == gconf.VALUE_BOOL:
				global PA
				if entry.value.get_bool():
					PA = True
				else:
					PA = False
			else:
				print 'PA_enable_changed: non-bool value'
				
		
class LeftLabel(gtk.Label):
    def __init__(self, string):
        gtk.Label.__init__(self, string)
        self.set_alignment(0.0, 0.5)

class PrefDialog:
	def __init__(self, preferences):
		self.pref = preferences
		self.dialog = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.dialog.set_title('DCApplet Preferences')
		self.dialog.set_resizable(False)
		
		table = gtk.Table(3, 2)

		table.attach(LeftLabel('UserFriendly.org:'), 0, 1, 0, 1, ypadding=2)
		self.chkbtnUF = gtk.CheckButton()
		table.attach(self.chkbtnUF, 1, 2, 0, 1)
		
		table.attach(LeftLabel('PVPonline.com:'), 0, 1, 1, 2, ypadding=2)
		self.chkbtnPVP = gtk.CheckButton()
		table.attach(self.chkbtnPVP, 1, 2, 1, 2)
		
		table.attach(LeftLabel('Penny-arcade.com:'), 0, 1, 2, 3, ypadding=2)
		self.chkbtnPA = gtk.CheckButton()
		table.attach(self.chkbtnPA, 1, 2, 2, 3)
		
		btnClose = gtk.Button('Close', gtk.STOCK_CLOSE)
		btnClose.connect('clicked', self.btnCloseClicked)
		
		self.chkbtnUF.connect('toggled', self.onchkbtnUF_toggled)
		self.chkbtnPVP.connect('toggled', self.onchkbtnPVP_toggled)
		self.chkbtnPA.connect('toggled', self.onchkbtnPA_toggled)
		
		vBox = gtk.VBox(spacing=5)
		vBox.pack_start(table)
		vBox.pack_end(btnClose, expand=False, fill=False)
		
		frame = gtk.Frame('Cartoon Sites')
		frame.set_shadow_type(gtk.SHADOW_NONE)
		frame.add(vBox)
		
		self.dialog.add(frame)
		#self.dialog.add(vBox)
		
		self.update_prefs()
		
		
	def onchkbtnUF_toggled(self, button):
		gconf_set_bool('UF_enable', button.get_active()) 
	
	def onchkbtnPVP_toggled(self, button):
		gconf_set_bool('PVP_enable', button.get_active()) 
	
	def onchkbtnPA_toggled(self, button):
		gconf_set_bool('PA_enable', button.get_active()) 
	
	def btnCloseClicked(self, widget):
		self.dialog.hide()
	
	def update_prefs(self):
		value = gconf_get_bool('UF_enable')
		self.chkbtnUF.set_active(value)
		value = gconf_get_bool('PVP_enable')
		self.chkbtnPVP.set_active(value)
		value = gconf_get_bool('PA_enable')
		self.chkbtnPA.set_active(value)
		
	def run(self):
		self.dialog.show_all()
		

class DCApplet(gnome.applet.Applet):

	def __init__(self):
		applet.__gobject_init__()
	
	def init(self):
		
		global gconf_prefs_prefix # /apps/panel/profiles/default/applets/applet_X/prefs
		gconf_prefs_prefix = applet.get_preferences_key()
		print 'gconf_prefs_prefix', gconf_prefs_prefix
		
		global client
		client = gconf.client_get_default()
		client.add_dir(gconf_prefs_prefix, gconf.CLIENT_PRELOAD_ONELEVEL)
		#self.prefs = Preferences()
		
		
		value = client.get_bool(gconf_prefs_prefix + "/initialized")
		if value is None or value is False:
			gconf_set_bool('UF_enable', True)
			gconf_set_bool('PVP_enable', True)
			gconf_set_bool('PA_enable', True)
			self._show_preferencesDlg()
			client.set_bool(gconf_prefs_prefix + "/initialized", True)
		
		
		#self.timeout_interval = 80000000
		
		# timeout_callback, self.timeout_interval is msec (every day should check for new comic)
		#gtk.timeout_add(self.timeout_interval, self.timeout_callback, self)
		
		propxml="""
		<popup name="button3">
		<menuitem name="Pref" verb="Pref" label="_Preferences..." pixtype="stock" pixname="gtk-properties"/>
		<menuitem name="About" verb="About" label="_About..." pixtype="stock" pixname="gnome-stock-about"/>
		</popup>
		"""
		
		verbs = [ ( "Pref", self.show_preferencesDlg ),
					( "About", self.about_info )
				]
		
		applet.setup_menu(propxml, verbs, None)
		
		applet.tooltips = gtk.Tooltips()
		applet.toggle = gtk.ToggleButton()

		self.box = gtk.HBox()
		self.box.pack_start(gtk.Label('DC'))
		self.arrow = gtk.Arrow(gtk.ARROW_DOWN, gtk.SHADOW_IN)
		self.box.pack_end(self.arrow)
		
		self.toggle.add(self.box)
		
		self.toggle.connect('button-press-event', self.button_press)
		self.TOGGLE_ID = self.toggle.connect('toggled', self.on_toggle)
		self.toggle.connect('enter', self.show_tooltip)
		
		applet.add(self.toggle)
		
		applet.show_all()
		
		self.vBox = gtk.VBox()
		
		self.imageUF = gtk.Image()
		self.vBox.pack_start(self.imageUF)
		
		self.imageDilbert = gtk.Image()
		self.vBox.pack_start(self.imageDilbert)
		#pack_start_defaults(widget)
		self.imagePVP = gtk.Image()
		self.vBox.pack_start(self.imagePVP)
		
		self.imagePA = gtk.Image()
		self.vBox.pack_end(self.imagePA)
		
		self.vBox.show()
		
		self.image_window = AlignedWindow(self.toggle)
		self.image_window.set_modal(True)
		self.image_window.add(self.vBox)
		
		
	def DetectDownloadAndShowImage(self):
		
		localtime = time.localtime() # get localtime
		
		year = localtime[0] # get year
		month = localtime[1] # get month
		if month < 10: # if month is 0 - 9 then add a 0 as first digit
			month = '0' + str(month) # eg. 2 will become 02
		
		day =  localtime[2]
		if day < 10: # if day is 0 - 9 then add a 0 as first digit
			day = '0' + str(day) # eg. 2 will become 02
		
		YearMonthDay = str(year) + str(month) + str(day) # sth like: 20041230
		
		if UF:
			url = 'http://ars.userfriendly.org/cartoons/?id=' + YearMonthDay + '&mode=classic'
			print 'url for UF', url
			
			yearmonth = str(year)[2:4] + str.lower(time.ctime()[4:7]) # yearmonth will be sth like 04aug
			pattern = 'http://www.userfriendly.org/cartoons/archives/' + yearmonth + '/.*'
			
			cartoonUrl = self.DetectImage( url, pattern )
			if cartoonUrl is not None: # the we have today's comic for UF
				print 'cartoonUrl for UF is', cartoonUrl # absolute path we're happy about this :)
				path_of_image = self.DownloadImage( cartoonUrl ) # get it
				self.ShowImage( 'UF', path_of_image ) # show it
			else:
				self.ErrorMessageDialog("UserFriendly.org did not upload today's cartoon yet.\nNothing to show")
				self.UFError = True
		
		if Dilbert:
			url = 'http://dilbert.com/comics/dilbert/archive/dilbert-' + YearMonthDay + '.html'
			print 'url for Dilbert', url
			pattern = '/comics/dilbert/archive/images/'
			cartoonUrl = self.DetectImage( url, pattern )
			cartoonUrl = 'http://dilbert.com' + cartoonUrl # FIXME: are you sure? relative path --> absolute path
			if cartoonUrl is not None: # the we have today's comic for Dilbert
				print 'cartoonUrl for Dilbert is', cartoonUrl 
				path_of_image = self.DownloadImage( cartoonUrl ) # get it
				self.ShowImage( 'Dilbert', path_of_image )
			else:
				self.ErrorMessageDialog("Dilbert.com did not upload today's cartoon yet.\nNothing to show")
				self.DilbertError = True
				
		if PVP:
			# standard location of the cartoon; no need to detect it in html code
			cartoonUrl = 'http://www.pvponline.com/archive/' + str(year) + '/pvp'+ YearMonthDay +'.gif'
			print 'cartoonUrl', cartoonUrl
			path_of_image = self.DownloadImage( cartoonUrl )
			
			filesize = os.path.getsize(path_of_image) # in bytes
			print 'filesize of pvp', filesize
			if filesize > 400: #FIXME: not good but works :) [parse it the fake image to see if it 404 html or not]
				self.ShowImage( 'PVP', path_of_image )
			else: #too small to be a real cartoon
				self.ErrorMessageDialog("pvponline.com did not upload today's cartoon yet.\nNothing to show")
				self.PVPError = True
				
		if PA:
			# standard location of the cartoon; no need to detect it in html code
			cartoonUrl = 'http://www.penny-arcade.com/images/' + str(year) + '/' + YearMonthDay + 'l.jpg'
			print 'cartoonUrl', cartoonUrl
			path_of_image = self.DownloadImage( cartoonUrl )
			
			filesize = os.path.getsize(path_of_image)
			if filesize > 400:
				self.ShowImage( 'PA', path_of_image )
			else:
				self.ErrorMessageDialog("penny-arcade.com did not upload today's cartoon yet.\nNothing to show")
				PAError = True

	def DetectImage(self, url, pattern):	
		cartoonUrl = None

		try:
			htmlSource = urllib.urlopen(url).read()
		except IOError, details:
			msg = 'IOError\n' + str(details) +'\n\nAre you sure you are online? ;-)'
			self.ErrorMessageDialog(msg)
			self.toggle.set_active( False )
		
		imgParser = ImageParser()
		imgParser.feed(htmlSource)
		
		#print 'imgParser.imageUrlList', imgParser.imageUrlList
		
		# normally this should be only one URL [one cartoon each day]
		# sometimes the list can be empty; we don't have today's cartoon yet
		
		for imageUrl in imgParser.imageUrlList:
			cartoonUrlList = sre.findall(pattern, imageUrl)
			if len(cartoonUrlList) > 0: # we found the cartoonUrl which is cartoonUrlList[0] (so len is 1)
				cartoonUrl = cartoonUrlList[0]
				print 'found cartoonUrl:', cartoonUrl
				break # because we found it, and it's only one, stop looping
		
		return cartoonUrl
			
		
	
	def DownloadImage(self, cartoonUrl):
		path_of_image = None
		print 'gonna download cartoonUrl', cartoonUrl    # here we have the url of the cartoon
			
		# points to the begining of the filename [after last '/' in the URL]
		# so that means WITHOUT /
		start = str.rindex(cartoonUrl,'/') + 1 # + 1 to step one more to avoid the last '/'
			
		filename = cartoonUrl[start:]
		print 'filename is', filename
		
		path_of_image = CARTOON_DIR + filename
		print 'path_of_image', path_of_image
		
		print 'now I am downloading it'
		outFile = open(path_of_image, 'w', 0)
		outFile.write(urllib.urlopen(cartoonUrl).read())
		
		outFile.close()
		print 'done saving it'
		
		return path_of_image
		

	def ShowImage(self, website, path_of_image):
		
		if website == 'UF':
			self.imageUF.set_from_file(path_of_image)
			self.imageUF.show()
			print 'added UF comic'
		if website == 'Dilbert':
			self.imageDilbert.set_from_file(path_of_image)
			self.imageDilbert.show()
			print 'added Dilbert comic'
		if website == 'PVP':
			self.imagePVP.set_from_file(path_of_image)
			self.imagePVP.show()
			print 'added PVP comic'
		if website == 'PA':
			self.imagePA.set_from_file(path_of_image)
			self.imagePA.show()
			print 'added PA comic'
		
		
#FIXME: error dialog destory with parent or sth [check if it's really alive whne removing applet]

#		<a href="http://ars.userfriendly.org/cartoons/?id=20040816"><img alt="Latest Strip" src="http://www.userfriendly.org/cartoons/archives/04aug/xuf007036.gif" border="0" height="219" width="576"></a>
#		ehi ALT!! sto IMG!!
#		x stin arxi tou filename simeni oti eine to MIKRO {DEN TO THELOUME AFTO}
		
	def show_tooltip(self, widget):
		self.tooltips.set_tip(widget, 'DailyCartoon Applet')
		
	def button_press(self, widget, event):
		if (event.button != 1): # if not left click
			self.toggle.stop_emission('button-press-event')
		#if event.button == 3: # right click
			
	def hideImageWindowAndContents(self):
		self.imageUF.hide()
		self.imagePVP.hide()
		self.imagePA.hide()
		self.image_window.hide()
					
	
	def on_toggle(self, widget):

		if not (UF or PVP or PA): # if user didn't select ANY cartoon site
			self.ErrorMessageDialog('select a cartoon site via Preferences first')
			self.toggle.handler_block( self.TOGGLE_ID )
			self.toggle.set_active( False ) # make it click out, without emitting 'toggled' event
			self.toggle.handler_unblock( self.TOGGLE_ID )
			print 'self.TOGGLE_ID', self.TOGGLE_ID
			print self.toggle.get_active()
			return
			
		else: # we have at least ONE cartoon site
			print 'clicked in?', self.toggle.get_active()
			# hide all images, so only the correct will be shown
			# this is in order to this scenario to be successful:
			# user selects UF, [ imageUF will be shown]
			# now user deselects UF, imageUF should be hidden again
			print 'hiding all images and image_window to be sure'
			self.hideImageWindowAndContents()
			
			if self.toggle.get_active():
				print 'clicked in'
				self.DetectDownloadAndShowImage()
				#try:
				#	if self.UFError and self.PVPError and self.PAError:
				#		self.ErrorMessageDialog('No cartoons from any site for today')
				#		return 
						#self.toggle.stop_emission('toggled')
						#self.image_window.hide()
				# if one of the Errors is not True, then there is no such object
				#except AttributeError: # at least ONE cartoon Site is OK, show the window
				self.image_window.positionWindow()
				self.image_window.show()
				self.image_window.grab_focus()
				print 'show them'
				#self.image.grab_focus()
			else:
				print 'clicked out'
		
	def about_info(self, event, data=None):
		xpm_logo = [
		"35 35 21 1",
		" 	g None",
		".	g #E4E4E4",
		"+	g #BFBFBF",
		"@	g #A4A4A4",
		"#	g #D0D0D0",
		"$	g #CFCFCF",
		"%	g #929292",
		"&	g #7F7F7F",
		"*	g #6C6C6C",
		"=	g #8F8F8F",
		"-	g #565656",
		";	g #EFEFEF",
		">	g #424242",
		",	g #2E2E2E",
		"'	g #090909",
		")	g #1C1C1C",
		"!	g #050505",
		"~	g #111111",
		"{	g #FFFFFF",
		"]	g #F7F7F7",
		"^	g #333333",
		"           .+. .. .                ",
		"           @@# @@.@ # .+           ",
		"        +@$$%+ +&%+ @.@$+$         ",
		"        .%@.%*+=-*@=&@%$%          ",
		"       $;@%*%>&****->&*-$ +$#      ",
		"    #.@@+@-,*,,->>->>-*>#+@++.     ",
		"   .@+%*&@->>,',,),>>--,*&@+@      ",
		"   @+*@,,&%,>,!-,),)~,'~)--=;+     ",
		"  .#+&-*,>,'')))')>~'~!!~>-@@++    ",
		" .#@+*->>)!~~~)!!!!!!!')))&*&=$    ",
		" .@+%,,,~'!'~)!'!!!!~)'~))>,*      ",
		"   +-*,,~~)!~)!!!~!!)~!,-~'>%@%    ",
		" #%+*,-,,)!!~~!!!!!!!!!))~),>@     ",
		"+%+---,>,)!!!!-*'&&,!!!!',~,&+$@   ",
		" $-,,>-~)'!!!&{{#{{]*!!!!)~),*+.   ",
		" .@,>))'~!!!^{{{{{{{{*!!!),),&$+.  ",
		" @%>-,,,!'!)#{{{{{{{{]>!!~~~*%@@+. ",
		" +%>->>>~'!*{{{{{{{{{{+!'~,,-*%@$  ",
		" .+>,,,~'~!#{{{{{{{{{{{,!~~)>&%%#  ",
		"@%@&>>,)~!).{{{{;;;{{{{-!')'>&@@+  ",
		".  &>,,,~!).{{{.,,>{{{{*!!,,,*+@.  ",
		"  +%>)~,)!!+{{{+!!>]{{{-!'^*>-@$   ",
		"  +@-),>'!!-{{{]+$;{{{#'!'!,*&@@.  ",
		" $@+%>,~))!!&;{{{%${{.-!!!!',+{.   ",
		"  +&-~!~,~!!!,%#*!!>>)!!!!,,)*+.   ",
		"  +=~)!!~~!!!!!'!!!!!!!!!)->>$++   ",
		"   &',,~,~!!!!!!!!!!!!!~!~-*&@@.   ",
		"  .&>-&>!!!!!!!!!!!!!!!'!)-*%@*+   ",
		"  @%%*&-~,)~!!!!!!!!!!!!)>&&+$+    ",
		"    +**-*,')!!!!!!!!!!!!)>*%%&.    ",
		"    +*%*-->,~'!!!!!!')'-,~*@=+$    ",
		"     $+&*+&>)')'!~'!!~*@->>$+$     ",
		"      @$+@*~,,~))>,!!>&*@-+@       ",
		"          &)--!~~>>!!~>&@@         ",
		"                                   "
		]
		author_and_thanks = [
		'Nikos Kouremenos <nkour@users.sourceforge.net>\n\n'
		'Thanks to:\n'
		'Arturo Gonzalez ~ http://www.pygtk.org/articles/applets_arturogf/\n'
		'Rubens Ramos ~ http://gnochm.sf.net/\n'
		'Seth Nickell ~ http://www.gnome.org/~seth/gnome-blog/'
		]
		gnome.ui.About('DCApplet', appversion, "Copyright 2004 Nikos Kouremenos",
						'A GNOME DailyCartoon Applet',author_and_thanks,[],
						"", gtk.gdk.pixbuf_new_from_xpm_data(xpm_logo)).show()	

	def InfoMessageDialog(self, message):
		dialog = gtk.MessageDialog(None, gtk.DIALOG_DESTROY_WITH_PARENT,
								gtk.MESSAGE_INFO, 
								gtk.BUTTONS_CLOSE, message)
		response = dialog.run()
		dialog.hide()
		
		return response

	def ErrorMessageDialog(self, message):
		dialog = gtk.MessageDialog(None, gtk.DIALOG_DESTROY_WITH_PARENT,
								gtk.MESSAGE_ERROR, 
								gtk.BUTTONS_CLOSE, message)
		response = dialog.run()
		dialog.hide()
		
		return response
		
	
	def show_preferencesDlg(self, event, data=None):
		self._show_preferencesDlg()
	
	def _show_preferencesDlg(self):
		prefs = Preferences() # get preferences in an object
		prefs_dialog = PrefDialog(prefs) # pass them to the dialog
		prefs_dialog.run() # show that dialog
	
	#def timeout_callback(self,event):
	#	pass

gobject.type_register(DCApplet)

def DCApplet_factory(_applet, iid):
	global applet
	applet = _applet

	print 'Returning DCApplet'
	applet.init()
	
	return True

if __name__ == '__main__':
	gnome.applet.bonobo_factory('OAFIID:GNOME_DCApplet_Factory', 
			DCApplet.__gtype__, 'DCApplet',	'0', DCApplet_factory)

print 'Done waiting in factory, returning... If this seems wrong, perhaps there is another copy of the DCApplet factory running?'
#self.cleanup won't get called so cleanup manually

del client
del applet
